## immer 0.9.1+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14)
cmake_policy(SET CMP0048 NEW) # enable project VERSION
cmake_policy(SET CMP0056 NEW) # honor link flags in try_compile()
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

project(immer VERSION 0.9.0)

set(CMAKE_EXPORT_COMPILE_COMMANDS on)
set(CMAKE_CXX_EXTENSIONS off)

if(NOT MSVC)
  set(CMAKE_CXX_FLAGS
      "${CMAKE_CXX_FLAGS} -Wall -Wextra -pedantic -Wno-unused-parameter -Wno-type-limits"
  )
endif()

if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
  set(CMAKE_CXX_FLAGS
      "${CMAKE_CXX_FLAGS} -Wall -Wextra -pedantic -Wno-unused-parameter -Wno-type-limits"
  )
endif()
if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
  set(CMAKE_CXX_FLAGS
      "${CMAKE_CXX_FLAGS} -Qunused-arguments -Wno-unknown-warning-option")
endif()

include(GNUInstallDirs)
include(ImmerUtils)

# Options
# =======

option(ENABLE_ASAN "compile with address sanitizer enabled")
option(ENABLE_MSAN "compile with memory sanitizer enabled")
option(ENABLE_LSAN "compile with leak sanitizer enabled")
option(ENABLE_UBSAN "compile with undefined behavior sanitizer enabled")
option(ENABLE_COVERAGE "compile with test coverage support")
option(ENABLE_VALGRIND "use valgrind when running tests")

option(DISABLE_WERROR "disable --werror")
option(DISABLE_FREE_LIST "disables the free list heap")
option(DISABLE_THREAD_SAFETY "disables thread safety by default")

option(CHECK_FUZZERS "Add fuzzers as part of make check" off)
option(CHECK_BENCHMARKS "Run benchmarks on check target" off)

option(ENABLE_PYTHON "enable building python module" off)
option(ENABLE_GUILE "enable building guile module" off)
option(ENABLE_BOOST_COROUTINE "run benchmarks with boost coroutine" off)

option(immer_BUILD_TESTS "Build tests" ON)
option(immer_BUILD_PERSIST_TESTS "Build experimental persist tests" off)
option(immer_BUILD_EXAMPLES "Build examples" ON)
option(immer_BUILD_DOCS "Build docs" ON)
option(immer_BUILD_EXTRAS "Build extras" ON)
option(immer_INSTALL_FUZZERS "Install fuzzers" off)
option(immer_ENABLE_EXCEPTIONS
       "Always enable exceptions regardless of detected compiler support" OFF)
option(immer_DISABLE_EXCEPTIONS
       "Always disable exceptions regardless of detected compiler support" OFF)

if(immer_ENABLE_EXCEPTIONS AND immer_DISABLE_EXCEPTIONS)
  message(FATAL_ERROR "Cannot both enable and disable exceptions")
endif()

if(immer_BUILD_PERSIST_TESTS)
  set(CXX_STANDARD
      17
      CACHE STRING "c++ standard number")
else()
  set(CXX_STANDARD
      14
      CACHE STRING "c++ standard number")
endif()

set(CMAKE_CXX_STANDARD ${CXX_STANDARD})
set(CMAKE_CXX_STANDARD_REQUIRED on)

if(ENABLE_ASAN)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address")
endif()
if(ENABLE_LSAN)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=leak")
endif()
if(ENABLE_UBSAN)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=undefined")
endif()
if(ENABLE_MSAN)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=memory")
endif()

if(NOT MSVC AND NOT DISABLE_WERROR)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror")
endif()

# Dependencies
# ============

if(ENABLE_BOOST_COROUTINE)
  set(immer_boost_components coroutine)
endif()

find_package(Threads)
find_package(BoehmGC)
find_package(Boost CONFIG 1.56 COMPONENTS ${immer_boost_components})

find_program(CCACHE ccache)
if(CCACHE)
  message(STATUS "Using ccache: ${CCACHE}")
  set(CMAKE_CXX_COMPILER_LAUNCHER ${CCACHE})
  set(CMAKE_CXX_LINKER_LAUNCHER ${CCACHE})
else()
  message(STATUS "Could not find ccache")
endif()

if(NOT BoehmGC_FOUND)
  set(BoehmGC_LIBRARIES "")
endif()

# Targets
# =======

# the library
add_library(immer INTERFACE)
target_include_directories(
  immer
  INTERFACE $<BUILD_INTERFACE:${immer_BINARY_DIR}/>
            $<BUILD_INTERFACE:${immer_SOURCE_DIR}/>
            $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>)

if(immer_ENABLE_EXCEPTIONS)
  message(STATUS "Explicitly enabling exceptions")
  target_compile_definitions(immer INTERFACE IMMER_USE_EXCEPTIONS)
endif()

if(immer_DISABLE_EXCEPTIONS)
  message(STATUS "Explicitly disabling exceptions")
  target_compile_definitions(immer INTERFACE IMMER_NO_EXCEPTIONS)
endif()

install(TARGETS immer EXPORT ImmerConfig)
install(EXPORT ImmerConfig DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/Immer")
install(DIRECTORY immer DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}")

include(CMakePackageConfigHelpers)
write_basic_package_version_file(
  "${CMAKE_CURRENT_BINARY_DIR}/ImmerConfigVersion.cmake"
  VERSION ${PROJECT_VERSION}
  COMPATIBILITY SameMajorVersion ARCH_INDEPENDENT)

install(FILES "${CMAKE_CURRENT_BINARY_DIR}/ImmerConfigVersion.cmake"
        DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/Immer")

# development target to be used in tests, examples, benchmarks...
immer_canonicalize_cmake_booleans(DISABLE_FREE_LIST DISABLE_THREAD_SAFETY
                                  CHECK_SLOW_TESTS)
add_library(immer-dev INTERFACE)
target_include_directories(
  immer-dev SYSTEM INTERFACE ${Boost_INCLUDE_DIR} ${BoehmGC_INCLUDE_DIR}
                             ${CMAKE_CURRENT_SOURCE_DIR}/tools/include)
target_link_libraries(immer-dev INTERFACE immer ${BoehmGC_LIBRARIES}
                                          ${CMAKE_THREAD_LIBS_INIT})
target_compile_definitions(
  immer-dev
  INTERFACE -DIMMER_CXX_STANDARD=${CXX_STANDARD}
            -DIMMER_HAS_LIBGC=1
            -DIMMER_NO_FREE_LIST=${DISABLE_FREE_LIST}
            -DIMMER_NO_THREAD_SAFETY=${DISABLE_THREAD_SAFETY}
            -DIMMER_SLOW_TESTS=${CHECK_SLOW_TESTS}
            -DFMT_HEADER_ONLY=1)
if(ENABLE_COVERAGE)
  target_compile_options(immer-dev INTERFACE "--coverage")
  target_link_libraries(immer-dev INTERFACE "--coverage")
endif()

# Testing
# =======

if(immer_BUILD_TESTS
   OR immer_BUILD_EXAMPLES
   OR immer_BUILD_EXTRAS)
  add_custom_target(
    check
    COMMAND ${CMAKE_CTEST_COMMAND} --output-on-failure
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    COMMENT "Build and run all the tests and examples.")
endif()

if(ENABLE_VALGRIND)
  # these variables need to before including CTest, because including it
  # triggers the generation of the config DartConfiguration.tcl
  find_program(MEMORYCHECK_COMMAND valgrind)
  set(MEMORYCHECK_COMMAND_OPTIONS
      "${MEMORYCHECK_COMMAND_OPTIONS} --leak-check=full --error-exitcode=1 --suppressions=${PROJECT_SOURCE_DIR}/test/extra/persist/valgrind.supp"
  )
  set(MEMORYCHECK_SUPPRESSIONS_FILE
      "${PROJECT_SOURCE_DIR}/test/valgrind_suppress.txt"
      CACHE FILEPATH "")
  message(STATUS "Valgrind enabled for tests")
endif()

if(immer_BUILD_TESTS)
  enable_testing()

  add_subdirectory(test)
  add_subdirectory(benchmark)
endif()

if(immer_BUILD_EXAMPLES)
  add_subdirectory(example)
endif()

if(immer_BUILD_DOCS)
  add_subdirectory(doc)
endif()

if(immer_BUILD_EXTRAS)
  add_subdirectory(extra/fuzzer)
  add_subdirectory(extra/python)
  add_subdirectory(extra/guile)
endif()

=== benchmark/CMakeLists.txt ===
# Config
# ======

option(BENCHMARK_DISABLE_GC "Disable gc during a measurement")

set(BENCHMARK_PARAM
    "N:1000"
    CACHE STRING "Benchmark parameters")
set(BENCHMARK_SAMPLES
    "20"
    CACHE STRING "Benchmark samples")

# Dependencies
# ============

find_package(RRB)

if(NOT RRB_FOUND)
  message(STATUS "Disabling benchmarks")
  return()
endif()

# These are expected to be in the include path, the nix-shell environment
# installs them:
#
# https://github.com/marcusz/steady
# https://github.com/deepsea-inria/chunkedseq.git
# https://github.com/rsms/immutable-cpp.git

# Targets
# =======

add_custom_target(benchmarks COMMENT "Build all benchmarks.")

execute_process(
  COMMAND git log -1 --format=%h
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
  OUTPUT_VARIABLE immer_git_commit_hash
  OUTPUT_STRIP_TRAILING_WHITESPACE)

execute_process(
  COMMAND git status --porcelain
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
  OUTPUT_VARIABLE immer_git_status
  OUTPUT_STRIP_TRAILING_WHITESPACE)

if(NOT immer_git_status STREQUAL "")
  set(immer_git_commit_hash "${immer_git_commit_hash}+")
endif()

site_name(immer_hostname)

get_filename_component(immer_compiler_name "${CMAKE_CXX_COMPILER}" NAME)

set(immer_benchmark_report_base_dir "${CMAKE_SOURCE_DIR}/reports")
set(immer_benchmark_report_dir
    "${immer_benchmark_report_base_dir}/report_\
${immer_git_commit_hash}_\
${immer_hostname}_\
${immer_compiler_name}_\
${BENCHMARK_PARAM}_\
s${BENCHMARK_SAMPLES}")

if(DISABLE_FREE_LIST)
  set(immer_benchmark_report_dir "${immer_benchmark_report_dir}_nofl")
endif()

if(DISABLE_THREAD_SAFETY)
  set(immer_benchmark_report_dir "${immer_benchmark_report_dir}_nots")
endif()

if(BENCHMARK_DISABLE_GC)
  set(immer_benchmark_report_dir "${immer_benchmark_report_dir}_nogc")
endif()

if(CHECK_BENCHMARKS)
  add_dependencies(check benchmarks)
endif()

add_custom_target(
  benchmark-report-dir COMMAND ${CMAKE_COMMAND} -E make_directory
                               ${immer_benchmark_report_dir})

file(GLOB_RECURSE immer_benchmarks "*.cpp")
foreach(_file IN LISTS immer_benchmarks)
  immer_target_name_for(_target _output "${_file}")
  add_executable(${_target} EXCLUDE_FROM_ALL "${_file}")
  set_target_properties(${_target} PROPERTIES OUTPUT_NAME ${_output})
  add_dependencies(benchmarks ${_target})
  add_dependencies(${_target} benchmark-report-dir)
  target_compile_options(${_target} PUBLIC -Wno-unused-function)
  target_compile_definitions(
    ${_target}
    PUBLIC NONIUS_RUNNER
           IMMER_BENCHMARK_LIBRRB=1
           IMMER_BENCHMARK_STEADY=1
           IMMER_BENCHMARK_EXPERIMENTAL=0
           IMMER_BENCHMARK_DISABLE_GC=${BENCHMARK_DISABLE_GC}
           IMMER_BENCHMARK_BOOST_COROUTINE=${ENABLE_BOOST_COROUTINE})
  target_link_libraries(${_target} PUBLIC immer-dev ${RRB_LIBRARIES})
  target_include_directories(${_target} SYSTEM PUBLIC ${RRB_INCLUDE_DIR})
  if(CHECK_BENCHMARKS)
    add_test(
      "benchmark/${_output}"
      "${CMAKE_SOURCE_DIR}/tools/with-tee.bash"
      ${immer_benchmark_report_dir}/${_target}.out
      "${CMAKE_CURRENT_BINARY_DIR}/${_output}"
      -v
      -t
      ${_target}
      -r
      html
      -s
      ${BENCHMARK_SAMPLES}
      -p
      ${BENCHMARK_PARAM}
      -o
      ${immer_benchmark_report_dir}/${_target}.html)
  endif()
endforeach()

add_custom_target(
  upload-benchmark-reports
  COMMAND rsync -av ${immer_benchmark_report_base_dir}
          root@sinusoid.es:/var/lib/syncthing/public/misc/immer/)

add_custom_target(
  copy-benchmark-reports COMMAND rsync -av ${immer_benchmark_report_base_dir}
                                 ~/public/misc/immer/)

=== test/CMakeLists.txt ===
# Targets
# =======

add_custom_target(tests COMMENT "Build all the unit tests.")
add_dependencies(check tests)

find_package(Catch2 REQUIRED)
include(CTest)

file(GLOB_RECURSE immer_unit_tests "*.cpp")
foreach(TMP_PATH ${immer_unit_tests})
  string(FIND ${TMP_PATH} persist EXCLUDE_DIR_FOUND)
  if(NOT ${EXCLUDE_DIR_FOUND} EQUAL -1)
    list(REMOVE_ITEM immer_unit_tests ${TMP_PATH})
  endif()
endforeach(TMP_PATH)

foreach(_file IN LISTS immer_unit_tests)
  immer_target_name_for(_target _output "${_file}")
  add_executable(${_target} EXCLUDE_FROM_ALL "${_file}")
  set_target_properties(${_target} PROPERTIES OUTPUT_NAME ${_output})
  add_dependencies(tests ${_target})
  target_compile_definitions(
    ${_target}
    PUBLIC IMMER_OSS_FUZZ_DATA_PATH="${CMAKE_CURRENT_SOURCE_DIR}/oss-fuzz/data"
           IMMER_THROW_ON_INVALID_STATE=1)
  target_link_libraries(${_target} PUBLIC immer-dev Catch2::Catch2WithMain)
  set_target_properties(${_target} PROPERTIES CXX_VISIBILITY_PRESET hidden)
  add_test("test/${_output}" ${_output})
endforeach()

if(immer_BUILD_PERSIST_TESTS)
  add_subdirectory(extra/persist)
endif()

=== extra/fuzzer/CMakeLists.txt ===
add_custom_target(fuzzers COMMENT "Build all fuzzers.")

if(CHECK_FUZZERS)
  add_dependencies(tests fuzzers)
endif()

# LIB_FUZZING_ENGINE is set by the Google OSS-Fuzz infrastructure. Otherwise we
# use Clang's LibFuzzer
if(DEFINED ENV{LIB_FUZZING_ENGINE})
  set(immer_fuzzing_engine $ENV{LIB_FUZZING_ENGINE})
else()
  set(immer_fuzzing_engine "-fsanitize=fuzzer")
endif()

file(GLOB_RECURSE immer_fuzzers "*.cpp")
foreach(TMP_PATH ${immer_fuzzers})
  string(FIND ${TMP_PATH} persist EXCLUDE_DIR_FOUND)
  if(NOT ${EXCLUDE_DIR_FOUND} EQUAL -1)
    list(REMOVE_ITEM immer_fuzzers ${TMP_PATH})
  endif()
endforeach(TMP_PATH)

foreach(_file IN LISTS immer_fuzzers)
  immer_target_name_for(_target _output "${_file}")
  add_executable(${_target} EXCLUDE_FROM_ALL "${_file}")
  set_target_properties(${_target} PROPERTIES OUTPUT_NAME ${_output})
  target_compile_options(${_target} PUBLIC ${immer_fuzzing_engine})
  target_compile_definitions(${_target} PUBLIC IMMER_THROW_ON_INVALID_STATE=1)
  target_link_libraries(${_target} PUBLIC ${immer_fuzzing_engine} immer-dev)
  add_dependencies(fuzzers ${_target})
  if(CHECK_FUZZERS)
    add_test("fuzzer/${_output}" ${_output} -max_total_time=1)
  endif()
  if(immer_INSTALL_FUZZERS)
    install(TARGETS ${_target} DESTINATION bin)
  endif()
endforeach()

if(immer_BUILD_PERSIST_TESTS)
  add_subdirectory(persist)
endif()

=== extra/python/CMakeLists.txt ===
option(USE_PYBIND "bind with pybind1" off)
option(USE_BOOST_PYTHON "bind with boost::python" off)

if(USE_PYBIND)
  set(PYBIND11_CPP_STANDARD -std=c++14)
  find_package(Boost CONFIG 1.56 REQUIRED)
  add_subdirectory(lib/pybind11)
  pybind11_add_module(immer_python_module src/immer-pybind.cpp)
  target_link_libraries(immer_python_module PUBLIC immer)

elseif(USE_BOOST_PYTHON)
  find_package(Python)
  find_package(Boost CONFIG 1.56 COMPONENTS python)
  python_add_module(immer_python_module src/immer-boost.cpp)
  include_directories(immer_python_module PUBLIC ${immer_include_dir}
                      ${Boost_INCLUDE_DIRS} ${PYTHON_INCLUDE_DIRS})
  target_link_libraries(immer_python_module PUBLIC immer ${Boost_LIBRARIES}
                                                   ${PYTHON_LIBRARIES})

else()
  find_package(Python)

  if(NOT PYTHONLIBS_FOUND)
    message(STATUS "Disabling Python modules")
    return()
  endif()

  python_add_module(immer_python_module EXCLUDE_FROM_ALL src/immer-raw.cpp)
  target_include_directories(immer_python_module PUBLIC ${PYTHON_INCLUDE_DIRS})
  target_link_libraries(immer_python_module PUBLIC immer ${PYTHON_LIBRARIES})

endif()

add_custom_target(python DEPENDS immer_python_module)

=== test/extra/persist/CMakeLists.txt ===
find_package(fmt REQUIRED)
find_package(cereal REQUIRED)
find_package(xxHash 0.8 CONFIG REQUIRED)

if(${CXX_STANDARD} LESS 17)
  message(FATAL_ERROR "persist requires C++17")
endif()

include(CTest)

add_executable(
  persist-tests EXCLUDE_FROM_ALL
  test_array.cpp
  test_vectors.cpp
  test_champ.cpp
  test_xxhash.cpp
  test_box.cpp
  test_special_pool.cpp
  test_special_pool_auto.cpp
  test_conversion.cpp
  test_circular_dependency_conversion.cpp
  test_table_box_recursive.cpp
  test_for_docs.cpp
  test_containers_cereal.cpp
  test_hash_size.cpp
  ${PROJECT_SOURCE_DIR}/immer/extra/persist/xxhash/xxhash_64.cpp)
target_precompile_headers(
  persist-tests PRIVATE <immer/extra/persist/cereal/save.hpp>
  <immer/extra/persist/cereal/load.hpp>)
add_dependencies(tests persist-tests)
add_test("test/persist-tests" persist-tests)
target_include_directories(persist-tests PRIVATE ${CMAKE_SOURCE_DIR})
target_link_libraries(persist-tests PRIVATE fmt::fmt Catch2::Catch2WithMain
                                            xxHash::xxhash)

target_compile_options(persist-tests PRIVATE -O1 -fno-optimize-sibling-calls -g
                                             -fno-omit-frame-pointer)

if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
  target_compile_options(
    persist-tests PRIVATE
    -Wno-unused-function
    -Wno-c++20-designator
    -Wimplicit-int-conversion
  )
elseif (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
  target_compile_options(
    persist-tests PRIVATE
    -Wno-c++20-extensions
    -Wno-changes-meaning
    -Wno-missing-field-initializers
  )
endif()

if(ENABLE_ASAN)
  target_compile_options(
    persist-tests PRIVATE -fsanitize=address)
  target_link_options(persist-tests PRIVATE -fsanitize=address)
  target_compile_definitions(persist-tests PRIVATE BOOST_USE_ASAN=1)
endif()

target_compile_definitions(persist-tests PRIVATE IMMER_NO_FREE_LIST=1
                                                 IMMER_DEBUG_STATS=1)

install(TARGETS persist-tests DESTINATION bin)
install(FILES valgrind.supp DESTINATION bin)

=== debian/changelog ===
immer (0.9.1+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.7.3, no changes required.
  * Drop Priority: optional, no more needed since dpkg 1.22.13.

 -- Pino Toscano <pino@debian.org>  Thu, 15 Jan 2026 06:50:54 +0100

=== debian/control ===
Source: immer
Section: libs
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Pino Toscano <pino@debian.org>,
Build-Depends: catch2,
               cmake (>= 3.14~),
               debhelper-compat (= 13),
               libboost-dev (>= 1.56~),
               libfmt-dev <!nocheck>,
               libgc-dev,
               pkgconf,
Standards-Version: 4.7.3
Homepage: https://github.com/arximboldi/immer
Vcs-Browser: https://salsa.debian.org/qt-kde-team/3rdparty/immer
Vcs-Git: https://salsa.debian.org/qt-kde-team/3rdparty/immer.git

Package: libimmer-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
         libgc-dev,
Description: persistent and immutable data structures -- development files
 immer is a library of persistent and immutable data structures written in C++.
 These enable whole new kinds of architectures for interactive and concurrent
 programs of striking simplicity, correctness, and performance.
 .
 This package contains the development files.

## immer 1.0-138

=== DESCRIPTION ===
Package: immer
Type: Package
Title: Item Response Models for Multiple Ratings
Version: 1.0-138
Date: 2018-04-24 12:15:54
Author: 
    Alexander Robitzsch [aut, cre], Jan Steinfeld [aut]
Maintainer: Alexander Robitzsch <robitzsch@ipn.uni-kiel.de>
Description: 
    Implements some item response models for multiple
    ratings, including the hierarchical rater model, 
    conditional maximum likelihood estimation of linear 
    logistic partial credit model and a wrapper function
    to the commercial FACETS program. See Robitzsch and
    Steinfeld (2018) for a description of the functionality
    of the package.
Depends: R (>= 3.0-0)
Imports: CDM (>= 6.0-101), coda, graphics, MASS, methods, psychotools,
        Rcpp, sirt (>= 2.4-9), stats, TAM
Suggests: eRm, lme4
LinkingTo: Rcpp, RcppArmadillo
URL: https://github.com/alexanderrobitzsch/immer
License: GPL (>= 2)
NeedsCompilation: yes
Packaged: 2018-04-24 10:16:22 UTC; sunpn563
Repository: CRAN
Date/Publication: 2018-04-24 10:56:35 UTC

## immer 1.1-35

=== DESCRIPTION ===
Package: immer
Type: Package
Title: Item Response Models for Multiple Ratings
Version: 1.1-35
Date: 2018-12-10 17:11:21
Author: 
    Alexander Robitzsch [aut, cre], Jan Steinfeld [aut]
Maintainer: Alexander Robitzsch <robitzsch@ipn.uni-kiel.de>
Description: 
    Implements some item response models for multiple
    ratings, including the hierarchical rater model, 
    conditional maximum likelihood estimation of linear 
    logistic partial credit model and a wrapper function
    to the commercial FACETS program. See Robitzsch and
    Steinfeld (2018) for a description of the functionality
    of the package. 
    See Wang, Su & Qiu (2014; <doi:10.1111/jedm.12045>)
    for an overview of modeling alternatives.
Depends: R (>= 3.0-0)
Imports: CDM (>= 6.0-101), coda, graphics, MASS, methods, psychotools,
        Rcpp, sirt (>= 2.4-9), stats, TAM
Suggests: eRm, lme4
LinkingTo: Rcpp, RcppArmadillo
URL: https://github.com/alexanderrobitzsch/immer,
        https://sites.google.com/site/alexanderrobitzsch2/software
License: GPL (>= 2)
NeedsCompilation: yes
Packaged: 2018-12-10 16:13:08 UTC; sunpn563
Repository: CRAN
Date/Publication: 2018-12-10 22:00:18 UTC

## immer 1.2-19

=== DESCRIPTION ===
Package: immer
Type: Package
Title: Item Response Models for Multiple Ratings
Version: 1.2-19
Date: 2022-04-11 12:19:15
Author: 
    Alexander Robitzsch [aut, cre], Jan Steinfeld [aut]
Maintainer: Alexander Robitzsch <robitzsch@ipn.uni-kiel.de>
Description: 
    Implements some item response models for multiple
    ratings, including the hierarchical rater model, 
    conditional maximum likelihood estimation of linear 
    logistic partial credit model and a wrapper function
    to the commercial FACETS program. See Robitzsch and
    Steinfeld (2018) for a description of the functionality
    of the package. 
    See Wang, Su and Qiu (2014; <doi:10.1111/jedm.12045>)
    for an overview of modeling alternatives.
Depends: R (>= 3.0-0)
Imports: CDM, coda, graphics, methods, psychotools, Rcpp, sirt, stats,
        TAM
Suggests: MASS
Enhances: eRm, lme4
LinkingTo: Rcpp, RcppArmadillo
URL: https://github.com/alexanderrobitzsch/immer,
        https://sites.google.com/site/alexanderrobitzsch2/software
License: GPL (>= 2)
NeedsCompilation: yes
Packaged: 2022-04-11 10:21:12 UTC; sunpn563
Repository: CRAN
Date/Publication: 2022-04-13 07:52:34 UTC

## immer 1.3-3

=== DESCRIPTION ===
--- 
+++ 
@@ -1,8 +1,8 @@
 Package: immer
 Type: Package
 Title: Item Response Models for Multiple Ratings
-Version: 1.2-19
-Date: 2022-04-11 12:19:15
+Version: 1.3-3
+Date: 2022-05-17 12:00:59
 Author: 
     Alexander Robitzsch [aut, cre], Jan Steinfeld [aut]
 Maintainer: Alexander Robitzsch <robitzsch@ipn.uni-kiel.de>
@@ -26,6 +26,6 @@
         https://sites.google.com/site/alexanderrobitzsch2/software
 License: GPL (>= 2)
 NeedsCompilation: yes
-Packaged: 2022-04-11 10:21:12 UTC; sunpn563
+Packaged: 2022-05-17 10:03:29 UTC; sunpn563
 Repository: CRAN
-Date/Publication: 2022-04-13 07:52:34 UTC
+Date/Publication: 2022-05-17 14:00:08 UTC

## immer 1.4-15

=== DESCRIPTION ===
--- 
+++ 
@@ -1,8 +1,8 @@
 Package: immer
 Type: Package
 Title: Item Response Models for Multiple Ratings
-Version: 1.3-3
-Date: 2022-05-17 12:00:59
+Version: 1.4-15
+Date: 2022-08-22 12:17:33
 Author: 
     Alexander Robitzsch [aut, cre], Jan Steinfeld [aut]
 Maintainer: Alexander Robitzsch <robitzsch@ipn.uni-kiel.de>
@@ -26,6 +26,6 @@
         https://sites.google.com/site/alexanderrobitzsch2/software
 License: GPL (>= 2)
 NeedsCompilation: yes
-Packaged: 2022-05-17 10:03:29 UTC; sunpn563
+Packaged: 2022-08-22 10:19:53 UTC; sunpn563
 Repository: CRAN
-Date/Publication: 2022-05-17 14:00:08 UTC
+Date/Publication: 2022-08-22 10:50:02 UTC

## immer 1.5-13

=== DESCRIPTION ===
--- 
+++ 
@@ -1,8 +1,8 @@
 Package: immer
 Type: Package
 Title: Item Response Models for Multiple Ratings
-Version: 1.4-15
-Date: 2022-08-22 12:17:33
+Version: 1.5-13
+Date: 2024-03-21 15:57:11
 Author: 
     Alexander Robitzsch [aut, cre], Jan Steinfeld [aut]
 Maintainer: Alexander Robitzsch <robitzsch@ipn.uni-kiel.de>
@@ -26,6 +26,6 @@
         https://sites.google.com/site/alexanderrobitzsch2/software
 License: GPL (>= 2)
 NeedsCompilation: yes
-Packaged: 2022-08-22 10:19:53 UTC; sunpn563
+Packaged: 2024-03-21 14:59:23 UTC; sunpn563
 Repository: CRAN
-Date/Publication: 2022-08-22 10:50:02 UTC
+Date/Publication: 2024-03-21 15:20:02 UTC
